#ifndef _HEAP_H
#define _HEAP_H

#include <types.h>

#define HEAP_START 0xC0000000
#define HEAP_SIZE  (1024 * 4096) /* 1MB heap */

void heap_init(void);

void* malloc(size_t size);
void* malloc_aligned(size_t size, size_t alignment);

void* calloc(size_t nmemb, size_t size);
void* realloc(void* ptr, size_t size);

void free(void* ptr);

#endif
