#ifndef _TTY_H
#define _TTY_H

#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>

static const size_t VGA_WIDTH = 80;
static const size_t VGA_HEIGHT = 25;
static uint16_t* const VGA_MEMORY = (uint16_t*) 0xB8000;

void terminal_initialize(void);
void terminal_initializec(uint8_t color);

void terminal_putchar(char c);
void terminal_write(const char* data, size_t size);
void terminal_writestring(const char* data);
void terminal_debug_writestring(const char* data);

void terminal_setcolor(uint8_t color);
uint8_t terminal_getcolor(void);

void terminal_clear(void);
void terminal_clearl(size_t num_lines);
void terminal_scroll(void);

#endif
